SET SQL DIALECT 3;

/******************************************************************************/
/***                               Generators                               ***/
/******************************************************************************/

CREATE GENERATOR GN_NOTEBOOK_REC_ID;
SET GENERATOR GN_NOTEBOOK_REC_ID TO 0;



SET TERM ^ ; 



/******************************************************************************/
/***                           Stored Procedures                            ***/
/******************************************************************************/

CREATE OR ALTER PROCEDURE GET_TERMINAL_PHONEBOOK (
    HOST_ID INTEGER)
RETURNS (
    REC_ID INTEGER,
    REC_NAME VARCHAR(128) CHARACTER SET UTF8,
    REC_DIALSTRING VARCHAR(128) CHARACTER SET UTF8,
    REC_DESCRIPTION VARCHAR(256) CHARACTER SET UTF8)
AS
BEGIN
  SUSPEND;
END^






SET TERM ; ^



/******************************************************************************/
/***                                 Tables                                 ***/
/******************************************************************************/



CREATE TABLE TB_TERMINAL_NOTEBOOK (
    REC_ID           INTEGER NOT NULL,
    HOST_ID          INTEGER NOT NULL,
    REC_NAME         VARCHAR(128) CHARACTER SET UTF8,
    REC_DIALSTRING   VARCHAR(128) CHARACTER SET UTF8,
    REC_DESCRIPTION  VARCHAR(256) CHARACTER SET UTF8
);




/******************************************************************************/
/***                              Primary Keys                              ***/
/******************************************************************************/

ALTER TABLE TB_TERMINAL_NOTEBOOK ADD CONSTRAINT PK_TB_TERMINAL_NOTEBOOK PRIMARY KEY (REC_ID, HOST_ID);


/******************************************************************************/
/***                              Foreign Keys                              ***/
/******************************************************************************/

ALTER TABLE TB_TERMINAL_NOTEBOOK ADD CONSTRAINT FK_TB_TERMINAL_NOTEBOOK_HOSTID FOREIGN KEY (HOST_ID) REFERENCES TB_SYS_ELEMENTS (HOST_ID) ON DELETE CASCADE ON UPDATE CASCADE;


/******************************************************************************/
/***                                Triggers                                ***/
/******************************************************************************/


SET TERM ^ ;



/******************************************************************************/
/***                          Triggers for tables                           ***/
/******************************************************************************/



/* Trigger: TB_TERMINAL_NOTEBOOK_BI0 */
CREATE OR ALTER TRIGGER TB_TERMINAL_NOTEBOOK_BI0 FOR TB_TERMINAL_NOTEBOOK
ACTIVE BEFORE INSERT POSITION 0
as
begin
  if (new.rec_id is null) then
    new.rec_id = gen_id(gn_notebook_rec_id, 1);
end
^


SET TERM ; ^



/******************************************************************************/
/***                           Stored Procedures                            ***/
/******************************************************************************/


SET TERM ^ ;

CREATE OR ALTER PROCEDURE GET_TERMINAL_PHONEBOOK (
    HOST_ID INTEGER)
RETURNS (
    REC_ID INTEGER,
    REC_NAME VARCHAR(128) CHARACTER SET UTF8,
    REC_DIALSTRING VARCHAR(128) CHARACTER SET UTF8,
    REC_DESCRIPTION VARCHAR(256) CHARACTER SET UTF8)
AS
begin
  for select rec_id,
             rec_name,
             rec_dialstring,
             rec_description
      from tb_terminal_notebook
      where host_id = :host_id
      into :rec_id,
           :rec_name,
           :rec_dialstring,
           :rec_description
  do
  begin
    suspend;
  end
end^



SET TERM ; ^
